/*******************************************************************************
 *  Copyright 2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_TracerKineticModelParameters;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_TracerKineticModelParameters;


/**
 * This class represents TracerKineticModelParameters CID4107
 */
public class TracerKineticModelParameters_CID4107 {
	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;

	/**
	 * Instantiates a new TracerKineticModelParameters_CID4107 Template 
	 */
	public TracerKineticModelParameters_CID4107()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}

	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumTracerKineticModelParameters Object of EnumCM_TracerKineticModelParameters represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_TracerKineticModelParameters enumTracerKineticModelParameters)
	{
		switch(enumTracerKineticModelParameters)
		{
		case KTRANS:
			this.strCodeValue = EnumCV_TracerKineticModelParameters.KTRANS_126312
					.getValue();
			break;
		case KEP:
			this.strCodeValue = EnumCV_TracerKineticModelParameters.KEP_126313
					.getValue();
			break;
		case VE:
			this.strCodeValue = EnumCV_TracerKineticModelParameters.VE_126314
					.getValue();
			break;
		case TAU_M:
			this.strCodeValue = EnumCV_TracerKineticModelParameters.TAU_M_126330
					.getValue();
			break;
		case VP:
			this.strCodeValue = EnumCV_TracerKineticModelParameters.VP_126331
					.getValue();
			break;
		}
	}

	/**
	 * Sets the value for TracerKineticModelParameters
	 * @param enumTracerKineticModelParameters Object of EnumCM_TracerKineticModelParameters.
	 */
	public void setTracerKineticModelParameters(EnumCM_TracerKineticModelParameters enumTracerKineticModelParameters)
	{
		this.strCodeMeaning = enumTracerKineticModelParameters.getValue();
		this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.DCM.getValue();
		setCodeValue(enumTracerKineticModelParameters);
	}
}
